package test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.CollectionLiterals;
import org.eclipse.xtext.xbase.lib.Functions.Function1;
import org.eclipse.xtext.xbase.lib.InputOutput;
import org.eclipse.xtext.xbase.lib.IterableExtensions;
import org.eclipse.xtext.xbase.lib.ObjectExtensions;
import org.eclipse.xtext.xbase.lib.Pair;
import test.Tag;

@SuppressWarnings("all")
public class TemplateTest2 {
  public static void main(final String[] args) {
    Pair<String,String> _mappedTo = Pair.<String, String>of("xmlns", "http://www.w3.org/1999/xhtml");
    HashMap<String,String> _newHashMap = CollectionLiterals.<String, String>newHashMap(_mappedTo);
    Pair<String,String> _mappedTo_1 = Pair.<String, String>of("id", "main_menu");
    Pair<String,String> _mappedTo_2 = Pair.<String, String>of("class", "menu");
    HashMap<String,String> _newHashMap_1 = CollectionLiterals.<String, String>newHashMap(_mappedTo_1, _mappedTo_2);
    Tag _tag = new Tag("div", _newHashMap_1, null);
    Pair<String,String> _mappedTo_3 = Pair.<String, String>of("class", "active");
    HashMap<String,String> _newHashMap_2 = CollectionLiterals.<String, String>newHashMap(_mappedTo_3);
    Tag _tag_1 = new Tag("h1", _newHashMap_2, null);
    Tag _tag_2 = new Tag("p", null, null);
    ArrayList<Tag> _newArrayList = CollectionLiterals.<Tag>newArrayList(_tag, _tag_1, _tag_2);
    Tag _tag_3 = new Tag("body", null, _newArrayList);
    ArrayList<Tag> _newArrayList_1 = CollectionLiterals.<Tag>newArrayList(_tag_3);
    Tag _tag_4 = new Tag("html", _newHashMap, _newArrayList_1);
    final Tag html = _tag_4;
    CharSequence _printTag = TemplateTest2.printTag(html);
    InputOutput.<CharSequence>print(_printTag);
  }
  
  public static CharSequence printTag(final Tag tag) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<");
    String _name = tag.getName();
    _builder.append(_name, "");
    Map<String,String> _attributes = tag.getAttributes();
    Set<Entry<String,String>> _entrySet = _attributes==null?(Set<Entry<String,String>>)null:_attributes.entrySet();
    final Function1<Entry<String,String>,CharSequence> _function = new Function1<Entry<String,String>,CharSequence>() {
        public CharSequence apply(final Entry<String,String> it) {
          StringConcatenation _builder = new StringConcatenation();
          String _key = it.getKey();
          _builder.append(_key, "");
          _builder.append("=\"");
          String _value = it.getValue();
          _builder.append(_value, "");
          _builder.append("\"");
          return _builder;
        }
      };
    String _join = _entrySet==null?(String)null:IterableExtensions.<Entry<String,String>>join(_entrySet, " ", " ", "", _function);
    _builder.append(_join, "");
    _builder.append(">");
    _builder.newLineIfNotEmpty();
    {
      List<Tag> _tags = tag.getTags();
      ArrayList<Tag> _newArrayList = CollectionLiterals.<Tag>newArrayList();
      List<Tag> _elvis = ObjectExtensions.<List<Tag>>operator_elvis(_tags, _newArrayList);
      for(final Tag t : _elvis) {
        _builder.append("\t");
        CharSequence _printTag = TemplateTest2.printTag(t);
        _builder.append(_printTag, "	");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("</");
    String _name_1 = tag.getName();
    _builder.append(_name_1, "");
    _builder.append(">");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
